﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Text.RegularExpressions;
using System.Windows.Forms;
using System.IO;
namespace FileCtrlH
{
    public partial class MainForm : Form
    {
        static string msg = "将开始修改操作！请确认文件已备份！";

        #region 变量

        private string newFormat = null;

        private  bool isBackUp = false;

        private bool isReplaceAll = false;

        private string searchStr = null;

        private string replaceStr = null;

        private static string[] filterString = null;

        public static string[] FilterString
        {
            get { return MainForm.filterString; }
            set { MainForm.filterString = value; }
        }
        #endregion

        #region 构造
        public MainForm()
        {
            InitializeComponent();
        }

        public MainForm(string [] args)
        {
            InitializeComponent();

            add(args);
        }
        #endregion

        #region 多个文件夹或目录添加
        private void add(string[] args)
        {
            int i;
            int length = args.Length;
            for (i = 0; i < length; i++)
            {
                string path = args[i];
                ContentType type = judgeFileOrFolder(path);
                switch (type)
                {
                    case ContentType.FILE:
                        addfile(path);
                        break;
                    case ContentType.FOLDER:
                        if (showFilter(path))
                            adddirectory(path);
                        break;
                }
            }
        }
        #endregion

        #region 判断是文件还是文件夹
        private ContentType judgeFileOrFolder(string args)
        {
               FileInfo fileInfo = new FileInfo(args);
               return fileInfo.Attributes == FileAttributes.Directory ? ContentType.FOLDER : ContentType.FILE;
           }
        #endregion

        #region 退出
           private void btnExit_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }
        #endregion

        #region 转换按钮
        private void btnConvert_Click(object sender, EventArgs e)
        {
            if (listView1.Items.Count != 0)
            {
                if (tbxSearch.Text.Length == 0)
                    MessageBox.Show("查找目标字符串不能为空，如果想替换空格，那就输入空格，反正长度不能等0就是了", "操作提示", MessageBoxButtons.OK, MessageBoxIcon.Information);
                else
                {
                    if (MessageBox.Show(msg, "操作提示!!!!!", MessageBoxButtons.OKCancel, MessageBoxIcon.Warning) == DialogResult.OK)
                    {
                        getIsBackUP();
                        getFormat();

                        getSearchStr();
                        getReplaceStr();

                        try
                        {
                            convert();
                            MessageBox.Show("修改成功！", "操作提示", MessageBoxButtons.OK, MessageBoxIcon.Information);
                        }
                        catch (Exception exception)
                        {
                            MessageBox.Show("修改失败！\n" + exception.Message, "操作提示", MessageBoxButtons.OK, MessageBoxIcon.Error);
                        }
                    }
                }
            }
            else
            {
                DialogResult reault = MessageBox.Show("还未添加任何文件！【是】 添加文件  【否】 添加目录 ", "操作提示", MessageBoxButtons.YesNoCancel, MessageBoxIcon.Warning);
                switch (reault)
                {
                    case DialogResult.Yes:
                        btnAddFile_Click(null,null);
                        break;
                    case DialogResult.No:
                        btnAddFolder_Click(null,null);
                        break;
                    case DialogResult.Cancel:
                        break;
                }
            }
        }
        #endregion

        #region 转换主方法
        private void convert()
        {
            int oldcount = 0;
            int newcount = 0;
            int count = 0;
            ListView.ListViewItemCollection collection = listView1.Items;
            string strPath = null;
            FileStream stream = null;
            StreamReader reader=null;
            Encoding encoding = null;
            string str = null;
            StreamWriter writer=null;

            foreach (ListViewItem item in collection)
            {
                strPath = item.Text;
                if (isBackUp)
                {
                    backup(strPath);
                }
                stream = new FileStream(strPath, FileMode.Open, FileAccess.Read);
                reader = new StreamReader(strPath, GetEncodingType(stream));
                encoding = reader.CurrentEncoding;
                str = reader.ReadToEnd();//当前一个文件的内容
               
                stream.Close();
                reader.Close();

                switch (newFormat)
                {
                    case "普通":
                        getIsReplaceAll();//是否全词匹配
                        oldcount=ContainCount(str, searchStr);//修改前个数

                        if (isReplaceAll)//全词匹配，使用正则方法替换字符串
                            str = replaceWithReg(str, "\\b" + searchStr + "\\b", replaceStr);
                        else//使用普通方法替换字符串
                            str = str.Replace(searchStr, replaceStr);
                        
                        newcount=ContainCount(str, searchStr);//修改后个数
                        count =oldcount-newcount;
                        break;
                    case "正则":
                        oldcount = matchWithRegex(str, searchStr);//修改前个数

                        str =replaceWithReg(str,searchStr,replaceStr);

                        newcount = matchWithRegex(str, searchStr);
                        count = oldcount - newcount;
                        break;
                }

                if (listView1.Items[item.Index].SubItems.Count == 1)
                    listView1.Items[item.Index].SubItems.Add("替换了 " + count.ToString() + " 处");
                else
                    listView1.Items[item.Index].SubItems[1].Text = "替换了 " + count.ToString() + " 处";

                writer = new StreamWriter(strPath, false, encoding);
                writer.Write(str);
                writer.Close();
            }
        }
        #endregion

        #region 使用正则替换字符串
        private string replaceWithReg(string value, string patn,string replaceStr)
        {
            return Regex.Replace(value, patn, replaceStr);
        }
        #endregion

        #region 计算value字符串在input内出现了几次
        //一般情况
        private  int ContainCount(string input, string value)
        {
            int count = 0;
            if (isReplaceAll)//全词匹配，对应正则是：  \\b值\\b 
            {
                 count=matchWithRegex(input,"\\b"+value+"\\b");
            }
            else
            {
                for (int i = 0; (i = input.IndexOf(value, i)) >= 0; i++)
                {
                    count++;
                }
            }

            return count;
        }
        //使用正则匹配字符串出现次数
        private int matchWithRegex(string input, string value)
        {
            Regex re = new Regex(value);
            MatchCollection mc = re.Matches(input);
            return mc.Count;
        }
        #endregion

        #region 通过给定的文件流，判断文件的编码类型
        public Encoding GetEncodingType(FileStream fs)
        {
            //byte[] Unicode = new byte[] { 0xFF, 0xFE, 0x41 };
            //byte[] UnicodeBIG = new byte[] { 0xFE, 0xFF, 0x00 };
            //byte[] UTF8 = new byte[] { 0xEF, 0xBB, 0xBF }; //带BOM

            Encoding reVal = Encoding.Default;

            BinaryReader r = new BinaryReader(fs, Encoding.Default);
            int i;
            int.TryParse(fs.Length.ToString(), out i);
            byte[] ss = r.ReadBytes(i);
            if (IsUTF8Bytes(ss) || (ss[0] == 0xEF && ss[1] == 0xBB && ss[2] == 0xBF))
            {
                reVal = Encoding.UTF8;
            }
            else if (ss[0] == 0xFE && ss[1] == 0xFF && ss[2] == 0x00)
            {
                reVal = Encoding.BigEndianUnicode;
            }
            else if (ss[0] == 0xFF && ss[1] == 0xFE && ss[2] == 0x41)
            {
                reVal = Encoding.Unicode;
            }
            r.Close();
            return reVal;
        }
        #endregion

        #region 判断是否是不带 BOM 的 UTF8 格式
        private bool IsUTF8Bytes(byte[] data)
        {
            int charByteCounter = 1;　 //计算当前正分析的字符应还有的字节数
            byte curByte; //当前分析的字节.
            int length = data.Length;
            int i;
            for (i = 0; i < length; i++)
            {
                curByte = data[i];
                if (charByteCounter == 1)
                {
                    if (curByte >= 0x80)
                    {
                        //判断当前
                        while (((curByte <<= 1) & 0x80) != 0)
                        {
                            charByteCounter++;
                        }
                        //标记位首位若为非0 则至少以2个1开始 如:110XXXXX...........1111110X　
                        if (charByteCounter == 1 || charByteCounter > 6)
                        {
                            return false;
                        }
                    }
                }
                else
                {
                    //若是UTF-8 此时第一位必须为1
                    if ((curByte & 0xC0) != 0x80)
                    {
                        return false;
                    }
                    charByteCounter--;
                }
            }
            if (charByteCounter > 1)
            {
                throw new Exception("非预期的byte格式");
            }
            return true;
        }
        #endregion

        #region 备份
        private void backup(string path)
        {
            try
            {
                string copyPath = Path.Combine(Path.GetDirectoryName(path), Path.GetFileNameWithoutExtension(path) + "_backup" + Path.GetExtension(path));
                File.Copy(path, copyPath, true);
            }
            catch (Exception ex)
            {
                MessageBox.Show("备份失败！\n"+ex.Message,"操作提示",MessageBoxButtons.OK,MessageBoxIcon.Error);
            }
        }
        #endregion

        #region 是否备份
        private void getIsBackUP()
        {
            if (chkBackup.Checked)
                isBackUp = true;
            else
                isBackUp = false;
        }
        #endregion

        #region “普通”格式时是否全词匹配
        private void getIsReplaceAll()
        {
           isReplaceAll =this.chkReplaceAll.Checked;
        }
        #endregion
      
        #region 获取目标文本格式
        private void getFormat()
        {
            System.Windows.Forms.Control.ControlCollection c = groupBox3.Controls;
            foreach (Control control in c)
            {
                if(control.GetType().Name=="RadioButton")
                {
                    if (((RadioButton)control).Checked)
                    {
                        newFormat = ((RadioButton)control).Text;
                    }
                }
            }
        }
        #endregion

        #region 获取目标与替换文本
        private void getSearchStr()
        {
            this.searchStr = tbxSearch.Text;
        }
        private void getReplaceStr()
        {
            this.replaceStr = tbxReplace.Text;
        }
        #endregion

        #region 添加文件主方法
        private void addfile(string filepath)
        {
            listView1.Items.Add(filepath);
        }
        #endregion

        #region 添加目录主方法
        private void adddirectory(string directoryarray)
        {
            DirectoryInfo directiry=null;
            FileInfo[] fileInfo =null;
            foreach (string str in filterString)
            {
                directiry = new DirectoryInfo(directoryarray);
                fileInfo = directiry.GetFiles("*." + str, SearchOption.AllDirectories);
                foreach (FileInfo info in fileInfo)
                {
                    listView1.Items.Add(info.FullName);
                }
                directiry = null;
                fileInfo = null;
            }
        }
        #endregion

        #region 添加文件按钮
        private void btnAddFile_Click(object sender, EventArgs e)
        {
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                int i;
                string [] folderPath = openFileDialog1.FileNames;
                int length = folderPath.Length;

                for (i = 0; i < length; i++)
                {
                    addfile(folderPath[i]);
                }
            }
        }
        #endregion

        #region 添加目录按钮
        private void btnAddFolder_Click(object sender, EventArgs e)
        {
            if (folderBrowserDialog1.ShowDialog() == DialogResult.OK)
            {
                if (showFilter(""))
                {
                    adddirectory(folderBrowserDialog1.SelectedPath);
                }
            }
        }
        #endregion

        #region 显示Filter窗体
        private bool showFilter(string str)
        {
            Filter f =null;
            if (str.Length == 0)
                f = new Filter();
            else
                f = new Filter(str);
            return f.ShowDialog() == DialogResult.OK?true:false;
        }
        #endregion

        #region 删除选中
        private void btnDelSelected_Click(object sender, EventArgs e)
        {

            if (listView1.Items.Count != 0)
            {
                if (listView1.SelectedItems.Count != 0)
                {
                    ListView.SelectedListViewItemCollection collection = listView1.SelectedItems;
                    int count = collection.Count;
                    int i;
                    for (i = 0; i < count; i++)
                    {
                        listView1.Items.Remove(collection[0]);
                    }
                }
                else
                {
                    MessageBox.Show("未选中任何记录！", "操作提示", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                }
            }
        }
        #endregion

        #region 删除全部
        private void btnDelAll_Click(object sender, EventArgs e)
        {
            if (listView1.Items.Count != 0)
            {
                listView1.Items.Clear();
            }
        }
        #endregion

        #region 关于
        private void btnAbout_Click(object sender, EventArgs e)
        {
            AboutBox1 a = new AboutBox1();
            a.ShowDialog();
        }
        #endregion

        #region 窗体登陆
        private void MainForm_Load(object sender, EventArgs e)
        {
            this.openFileDialog1.Filter = "文本文件|*.txt|Java 文件|*.java|C# 文件|*.cs|网页文件|*.html|网页文件|*.htm|样式表文件|*.css|JavaScript文件|*.js|所" +
    "有文件|*.*";
        }
        #endregion

        #region 窗体拖放事件
        private void MainForm_DragEnter(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent(DataFormats.FileDrop))
                e.Effect = DragDropEffects.Link;
            else
                e.Effect = DragDropEffects.None;
        }

        private void MainForm_DragDrop(object sender, DragEventArgs e)
        {
            add((string[])e.Data.GetData(DataFormats.FileDrop));
        }
        #endregion
    }
}